package com.cndatacom.asyncs;

import android.app.ProgressDialog;
import android.content.Context;
import android.os.AsyncTask;
import android.text.TextUtils;

/**
 * 첽
 * @author WYT
 *
 */
public class AsyncTasker extends AsyncTask<Object, Object, Object> 
{	
	private Context _Context = null;
	private String _Tips = null;
	private AsyncProccess _Proccess = null;
	private AsyncCallback _Callback = null;
	private ProgressDialog _Dialog = null;

	public AsyncTasker(Context context, String tips, AsyncProccess proccess, AsyncCallback callback)
	{
		this._Context = context;
		this._Tips = tips;
		this._Proccess = proccess;
		this._Callback = callback;
	}

	@Override
	protected void onPreExecute()
	{
		super.onPreExecute();
	    if(!TextUtils.isEmpty(this._Tips))
	    {
	    	this._Dialog = new ProgressDialog(this._Context);
	    	this._Dialog.setMessage(this._Tips);
	    	this._Dialog.setCancelable(true);
	    	this._Dialog.show();
	    }
	}

	@Override
	protected Object doInBackground(Object... params) 
	{
	   	return this._Proccess.proccess();
	}

	@Override
	protected void onPostExecute(Object result) 
	{
	   	if(null != this._Dialog)
	   	{
	   		this._Dialog.dismiss();
	   	}
	   	this._Callback.callback(result);
    }
	
	@Override
	protected void onCancelled()
	{
		this._Proccess.cancel();
	}
}
