package com.cndatacom.log;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import android.annotation.SuppressLint;
import android.os.Environment;
import android.util.Log;

/**
 * ־
 */
@SuppressLint("SimpleDateFormat")
public class Logger 
{
	/**
	 * дļ־
	 * @param sPath:־·
	 * @param sText:־
	 */
	public static void write(String sTags, String sText)
	{
		 write(sTags, sText, true, true);
	}
	/**
	 * дļ־
	 * @param sPath:־·
	 * @param ex:־
	 * @param bWrite:Ƿ񱣴־
	 */
	public static void write(String sTags, Exception ex, boolean bWrite)
	{
		write(sTags, ex.toString(), true, bWrite);
	}
	/**
	 * дļ־
	 * @param sPath:־·
	 * @param sText:־
	 * @param bPrint:Ƿӡ
	 * @param bWrite:Ƿ񱣴־
	 */
	public static void write(String sTags, String sText, boolean bPrint, boolean bWrite)
	{
		if (bPrint)	Log.i(sTags, sText);
		if (bWrite){
			if (Environment.MEDIA_MOUNTED.equals(Environment.getExternalStorageState()))
			{		
				try 
				{
					Date now = new Date();
					SimpleDateFormat tempDate1 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
					SimpleDateFormat tempDate2 = new SimpleDateFormat("yyyyMMdd");
					String sDateTime = tempDate1.format(now);
					String sFileName = tempDate2.format(now);
					String sDir = Environment.getExternalStorageDirectory().getPath() + "/" + sTags + "/";
					File destDir = new File(sDir);
					if (!destDir.exists()) { destDir.mkdirs(); }
					File file = new File(sDir + sFileName + ".txt");
					if (!file.exists()) { file.createNewFile(); }
					FileWriter fw = new FileWriter(file, true);
					fw.append("\n==================================\n");
					fw.append(sDateTime);
					fw.append("\n");
					fw.append(sText);
					fw.append("\n==================================\n");
					fw.flush();
					fw.close();
				} 
				catch (IOException ex)
				{
					Log.e(sTags, ex.getLocalizedMessage());
				}
			} else {
				Log.e(sTags, "ûд洢ռ䡣");
			}
		}
	}
}
