package com.cndatacom.utils;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * ʱ
 * @author WYT
 *
 */
public class DateTime
{
	/**
	 * ʽַ
	 * @param date : 
	 * @param format ʽַ
	 * @return
	 */
	public static String getDateTimeString(Date date, String format)
	{
		SimpleDateFormat dFormat = new SimpleDateFormat(format);
		return dFormat.format(date);
	}

	/**
	 * ȡ(yyyy-MM-dd)
	 * @param date : 
	 * @return
	 */
	public static String getDate(Date date)
	{
		return getDateTimeString(date, "yyyy-MM-dd");
	}
	/**
	 * ȡ(yyyy-MM-dd HH:mm:ss)
	 * @param date : 
	 * @return
	 */
	public static String getDateTime(Date date)
	{
		return getDateTimeString(date, "yyyy-MM-dd HH:mm:ss");
	}
	/**
	 * ȡ(yyyy-MM-dd HH:mm:ss.fff)
	 * @param date : 
	 * @return
	 */
	public static String getDateTimes(Date date)
	{
		return getDateTimeString(date, "yyyy-MM-dd HH:mm:ss.fff");
	}
	
	public static int GL_M_D[] = new int[]{31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
	public static long NL_Y[] = new long[] {
	  	0x04bd8, 0x04ae0, 0x0a570, 0x054d5, 0x0d260, 0x0d950, 0x16554, 0x056a0, 0x09ad0, 0x055d2,
	  	0x04ae0, 0x0a5b6, 0x0a4d0, 0x0d250, 0x1d255, 0x0b540, 0x0d6a0, 0x0ada2, 0x095b0, 0x14977,
	  	0x04970, 0x0a4b0, 0x0b4b5, 0x06a50, 0x06d40, 0x1ab54, 0x02b60, 0x09570, 0x052f2, 0x04970,
	  	0x06566, 0x0d4a0, 0x0ea50, 0x06e95, 0x05ad0, 0x02b60, 0x186e3, 0x092e0, 0x1c8d7, 0x0c950,
	  	0x0d4a0, 0x1d8a6, 0x0b550, 0x056a0, 0x1a5b4, 0x025d0, 0x092d0, 0x0d2b2, 0x0a950, 0x0b557,
	  	0x06ca0, 0x0b550, 0x15355, 0x04da0, 0x0a5b0, 0x14573, 0x052b0, 0x0a9a8, 0x0e950, 0x06aa0,
	  	0x0aea6, 0x0ab50, 0x04b60, 0x0aae4, 0x0a570, 0x05260, 0x0f263, 0x0d950, 0x05b57, 0x056a0,
	  	0x096d0, 0x04dd5, 0x04ad0, 0x0a4d0, 0x0d4d4, 0x0d250, 0x0d558, 0x0b540, 0x0b6a0, 0x195a6,
	  	0x095b0, 0x049b0, 0x0a974, 0x0a4b0, 0x0b27a, 0x06a50, 0x06d40, 0x0af46, 0x0ab60, 0x09570,
	  	0x04af5, 0x04970, 0x064b0, 0x074a3, 0x0ea50, 0x06b58, 0x055c0, 0x0ab60, 0x096d5, 0x092e0,
	  	0x0c960, 0x0d954, 0x0d4a0, 0x0da50, 0x07552, 0x056a0, 0x0abb7, 0x025d0, 0x092d0, 0x0cab5,
	  	0x0a950, 0x0b4a0, 0x0baa4, 0x0ad50, 0x055d9, 0x04ba0, 0x0a5b0, 0x15176, 0x052b0, 0x0a930,
	  	0x07954, 0x06aa0, 0x0ad50, 0x05b52, 0x04b60, 0x0a6e6, 0x0a4e0, 0x0d260, 0x0ea65, 0x0d530,
	  	0x05aa0, 0x076a3, 0x096d0, 0x04bd7, 0x04ad0, 0x0a4d0, 0x1d0b6, 0x0d250, 0x0d520, 0x0dd45,
	  	0x0b5a0, 0x056d0, 0x055b2, 0x049b0, 0x0a577, 0x0a4b0, 0x0aa50, 0x1b255, 0x06d20, 0x0ada0,
	  	0x14b63
  	};
	public static String NL_M[] = new String[]{"", "", "", "", "", "", "", "", "", "", "ʮ", "ʮһ", ""};
	public static String NL_D[] = new String[] {"", "һ", "", "", "", "", "", "", "", "", "ʮ", "ʮһ", "ʮ", "ʮ", "ʮ", "ʮ", "ʮ", "ʮ", "ʮ", "ʮ", "ʮ", "إһ", "إ", "إ", "إ", "إ", "إ", "إ", "إ", "إ", "ʮ"};
	public static String NL_TG[] = new String[]{"", "", "", "", "", "", "", "", "", ""};
	public static String NL_DZ[] = {"", "", "", "î", "", "", "", "δ", "", "", "", ""};
	public static String NL_SX[] = {"", "ţ", "", "", "", "", "", "", "", "", "", ""};
	public static int Time24[] = {0, 21208, 42467, 63836, 85337, 107014, 128867, 150921, 173149, 195551, 218072, 240693, 263343, 285989, 308563, 331033, 353350, 375494, 397447, 419210, 440795, 462224, 483532, 504758};
	public static String Name24[] = {"С", "", "", "ˮ", "", "", "", "", "", "С", "â", "", "С", "", "", "", "¶", "", "¶", "˪", "", "Сѩ", "ѩ", ""};
	
	/**
	 * ղѯ
	 * @param M 
	 * @param D
	 * @return
	 */
	public static String getFestivalGL(int M, int D)
	{
		String val = "";
		if (1 == M){
			if (1 == D) { val = "Ԫ"; }
		} else if (3 == M){
			if (8 == D){ val = "Ů"; } else if (12 == D){ val = "ֲ"; } else if (15 == D){ val = "άȨ"; }
		} else if (4 == M){
			if (1 == D){ val = ""; }
		} else if (5 == M){
			if (1 == D){ val = "Ͷ"; } else if (4 == D){ val = ""; }
		} else if (6 == M){
			if (1 == D){ val = "ͯ"; }
		} else if (7 == M){
			if (1 == D){ val = ""; }
		} else if (8 == M){
			if (1 == D){ val = ""; }
		} else if (9 == M){
			if (12 == D){ val = "ʦ"; }
		} else if (10 == M){
			if (1 == D){ val = ""; }
		}  else if (11 == M){
			if (24 == D){ val = "ж"; }
		} else if (12 == M){
			if (24 == D){ val = "ƽ"; } else if (25 == D){ val = "ʥ"; }
		}		
		return val;
	}
	
	/**
	 * ũղѯ
	 * @param GL
	 * @param Y
	 * @param M
	 * @param D
	 * @return
	 */
	public static String getFestivalNL(Date GL, int Y, int M, int D)
	{
		String val = "";
		if (1 == M){
			if (1 == D){ val = ""; } else if (15 == D){ val = "Ԫ"; }
		} else if (5 == M){
			if (5 == D){ val = ""; }
		} else if (7 == M){
			if (7 == D){ val = "Ϧ"; } else if (15 == D){ val = "Ԫ"; }
		} else if (8 == M){
			if (15 == D){ val = ""; }
		} else if (9 == M){
			if (9 == D){ val = ""; }
		} else if (12 == M){
			if (8 == D){ val = ""; } else if (23 == D){ val = "С"; } else if (30 == D){ val = "Ϧ"; }
		}		
		return val;
	}
	
	/**
	 * ʮĽѯ
	 */
	public static String getFestival24(Date GL)
	{
		int Y = GL.getYear();
		int M = GL.getMonth();
		int D = GL.getDate();
		Date dTemp;
		String vTemp = "";
		double llTemp;
        for (int i = 0; i < 24; i++) {
        	llTemp = 31556925974.7 * Y + Time24[i] * 60000 + Date.UTC(1900, 0, 6, 10, 5, 0);
            dTemp = new Date((long) llTemp );
            if (dTemp.getMonth() == M && dTemp.getDate() == D) {
				vTemp = Name24[i];
				break;
			}
            if (dTemp.getMonth() > M || (dTemp.getMonth() == M && dTemp.getDate() > D)) { break; }
        }
        return vTemp;
	}
	
	/**
	 * ȡǰ·
	 */
	public static Date getFirstDate(Date date){
		return new Date(date.getYear(), date.getMonth(), 1);
	}

	/**
	 * ȡ·
	 */
	public static int getMonthDays(int y, int m)
	{ 
		return (isLeapYear(y) && m == 2) ? 29 : GL_M_D[m - 1];
	}
	
	/**
	 * N
	 * days: ӵ
	 */
	public static Date addDates(Date date, int days)
	{
          return new Date(date.getTime() + (86400000 * days));
	}
	
	/**
	 * NСʱ
	 * hours: ӵСʱ
	 */
	public static Date addHours(Date date, int hours)
	{
          return new Date(date.getTime() + (3600000 * hours));
	}
	
	/**
	 * N
	 * minutes: ӵķ
	 */
	public static Date addMinutes(Date date, int minutes)
	{
          return new Date(date.getTime() + (60000 * minutes));
	}
	
	/**
	 * N
	 * seconds: ӵ
	 */
	public static Date addSeconds(Date date, int seconds)
	{
          return new Date(date.getTime() + (1000 * seconds));
	}

	/**
	 * жǷ
	 */
	public static Boolean isLeapYear(int y)
	{
		return ( (0 == y % 4 && (y % 100 != 0 || y % 400 == 0)) ? true : false);
	}

	/**
	 * ȡũ
	 */
	public static int getNLYearDays(int y)
	{
	    int sum = 348;
	    for (int i = 0x8000; i > 0x8; i >>= 1)
    	{
	    	if ((NL_Y[y - 1900] & i) != 0){
	    		sum += 1;
	    	}
    	}
	    return (sum + getNLLeapDays(y));
	}

	/**
	 * ȡũ
	 * @param y
	 * @return
	 */
	public static int getNLLeapDays(int y) 
	{
		return getNLLeapMonth(y) > 0 ? ((NL_Y[y - 1900] & 0x10000) != 0 ? 30 : 29) : 0;
	}

	/**
	 * ȡũ·
	 * @param y
	 * @return
	 */
	public static int getNLLeapMonth(int y) 
	{
		return (int) (NL_Y[y - 1900] & 0xf);
	}

	/**
	 * ȡũ
	 * @param y
	 * @param m
	 * @return
	 */
	public static int getNLMonthDays(int y, int m)
	{
		return (((NL_Y[y - 1900] & (0x10000 >> m)) != 0) ? 30 : 29);
	}

	/**
	 * ȡũɵ֧
	 * @param year
	 * @return
	 */
	public static String getGanZhi(int year) 
	{
		year = year - 1900 + 36; 
		return (NL_TG[year%10] + NL_DZ[year%12]);
	}
	
	/**
	 * תũ
	 * @param GL : 
	 * @return
	 */
	public static LunarModel GL2NL(Date GL)
	{
		LunarModel model = new LunarModel();

		int i, leap = 0, temp = 0;
		int offset = (int) ((Date.UTC(GL.getYear() + 1900, GL.getMonth(), GL.getDate(), 0, 0, 0) - Date.UTC(1900, 0, 30, 0, 0, 0)) / 86400000);
	    for (i = 1900; i < 2050 && offset > 0; i++) { temp = getNLYearDays(i); offset -= temp; }
	    if (offset < 0) 
	    { 
	    	offset += temp;
	    	i--; 
	    }
	    model.setY(i);
	    leap = getNLLeapMonth(i);
	    model.setIsLeap(false);
	    for (i = 1; i < 13 && offset > 0; i++) {
	        if (leap > 0 && i - 1 == leap && !model.getIsLeap()) 
	        { 
	        	--i; 
	        	model.setIsLeap(true);
	        	temp = getNLLeapDays(model.getY());
	        } else { 
	        	temp = getNLMonthDays(model.getY(), i);
	        }
	        if (model.getIsLeap() && i - 1 == leap) {
	        	model.setIsLeap(false);
	        }
	        offset -= temp;
	    }
	    if (offset < 0) { 
	    	offset += temp; 
	    	--i;
	    } 
	    else if (leap > 0 && i - 1 == leap)
	    {
	        if (model.getIsLeap()) { 
	        	model.setIsLeap(false); 
	        } else { 
	        	model.setIsLeap(true);
	        	--i;
	        }
	    }
	    
	    model.setM(i);
	    model.setD(offset + 1);
	    model.setDays(getNLMonthDays(model.getY(), model.getM()));
	    
	    return model;
	}
	
	/**
	 * ũʵ
	 * @author WYT
	 *
	 */
	public static class LunarModel
	{
		int Y;
		int M;
		int D;
		int MonthDays;
		boolean isLeapMonth;
		/**
		 * ȡ
		 * @return
		 */
		public int getY(){return Y;}
		/**
		 * 
		 * @param v
		 */
		public void setY(int v){Y=v;}
		/**
		 * ȡ·
		 * @return
		 */
		public int getM(){return M;}
		/**
		 * ·
		 * @param v
		 */
		public void setM(int v){M=v;}
		/**
		 * ȡ
		 * @return
		 */
		public int getD(){return D;}
		/**
		 * 
		 * @param v
		 */
		public void setD(int v){D=v;}
		/**
		 * ȡ
		 * @return
		 */
		public int getDays(){return MonthDays;}
		/**
		 * 
		 * @param v
		 */
		public void setDays(int v){MonthDays=v;}
		/**
		 * ȡǷ
		 * @return
		 */
		public boolean getIsLeap(){return isLeapMonth;}
		/**
		 * Ƿ
		 * @param v
		 */
		public void setIsLeap(boolean v){isLeapMonth=v;}
	}
	
	/**
	 * ȡũ
	 * @param GL
	 * @param Y
	 * @param M
	 * @param D
	 * @param isLeap
	 * @return
	 */
	public static String getCNDay(Date GL, int Y, int M, int D, Boolean isLeap)
	{
	    String S = getFestivalGL(GL.getMonth() + 1, GL.getDate());	    
	    if (S.equals(""))
	    { 
	    	S = getFestivalNL(GL, Y, M, D);
	    } 
	    if (S.equals(""))
	    { 
	    	S = getFestival24(GL);
	    } 
	    if (S.equals(""))
	    {
		    if (1 != D){
		    	S = NL_D[D];
		    } else {
		    	if (isLeap) { S += ""; }
		    	S += NL_M[M] + "";
		    }
	    }
	    return S;
	}

	/**
	 * ȡũϢ
	 * @param GL
	 * @return
	 */
	public static String showNL(Date GL) 
	{
		LunarModel NL = GL2NL(GL); 
		return getCNDay(GL, NL.getY(), NL.getM(), NL.getD(), NL.getIsLeap());
	}
	
	public static String getNLTitle1(Date GL) 
	{
		LunarModel NL = GL2NL(GL);
		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy.MM.dd ");
		return dateFormat.format(GL) + getGanZhi(NL.getY()) + NL_SX[(NL.getY()-4)%12] + '' + NL_M[NL.getM()] + '' + NL_D[NL.getD()];
	}
	
	public static String getNLTitle2(Date GL) 
	{
		LunarModel NL = GL2NL(GL);
		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
		return dateFormat.format(GL) + "\n" + getWeekName(GL) + ' ' + NL_M[NL.getM()] + '' + NL_D[NL.getD()];
	}
	
	public static String getWeekName(Date date)
	{
		switch(date.getDay())
		{
		case 1:
			return "һ";
		case 2:
			return "ڶ";
		case 3:
			return "";
		case 4:
			return "";
		case 5:
			return "";
		case 6:
			return "";
		default:
			return "";
		}
	}

	/**
	 * ȡͼũ
	 * @param GL
	 * @return
	 */
	public static List<String> getCalendarNL(Date GL)
	{
		List<String> list = new ArrayList<String>();
	  	LunarModel NL = GL2NL(GL);
	  	int NLDate = 0, iIndex = 0;
	  	for(int i = 0; i < 42; i++)
	  	{
	  		NLDate = NL.getD() + iIndex;
	  		if (NLDate >= NL.getDays()){
	  			iIndex = 0;
	  			NL = GL2NL(GL);
	  			NLDate = NL.getD() + iIndex;
	  		}
	  		list.add(getCNDay(GL, NL.getY(), NL.getM(), NLDate, NL.getIsLeap()));
	  		GL = addDates(GL, 1);
	      	iIndex++;
	    }
	    return list;
	}

	/**
	 * ũת
	 * @param Y
	 * @param M
	 * @param D
	 * @return
	 */
	public static Date NL2GL(int Y, int M, int D)
	{
      	Date TGL = new Date(Y - 1900, M, D);
      	LunarModel TNL = GL2NL(TGL);
      	int iY = TNL.getY();
      	int iM = TNL.getM();
      	int iD = TNL.getD();
      	int lM;
      	boolean isLeap = TNL.getIsLeap();
      	int days = 0;
  		if (iY < Y){
  			for(int i = iM; i <= 12; i++){
  				days += getNLMonthDays(iY, i);
      		}
  			lM = getNLLeapMonth(iY);
  			if (lM > iM || (lM == iM && isLeap)){
  				days += getNLLeapDays(iY);
  			}
  			for(int i = 1; i < M; i++){
  				days += getNLMonthDays(Y, i);
  	  		}
  		} else {
  			for(int i = iM; i < M; i++){
  				days += getNLMonthDays(Y, i);
  	  		}
  		}
  		lM = getNLLeapMonth(Y);
		if (lM < M){
			days += getNLLeapDays(Y);
		}
		days += D - iD;

      	return addDates(TGL, days);
	}
	
	/**
	 * ַת
	 * @param date
	 * @return
	 */
	public static Date formatDate(String date)
	{
		int Y = -1900, M = -1, D = 0, H = 0, m = 0, s = 0;
		String dates[], date1[], date2[];
		dates = date.split(" ");
		if (dates.length > 0){
			date1 = dates[0].split("-");
			Y += Integer.parseInt(date1[0]);
			M += Integer.parseInt(date1[1]);
			D += Integer.parseInt(date1[2]);
			
			if (2 == dates.length){
				date2 = dates[1].split(":");
				H += Integer.parseInt(date2[0]);
				m += Integer.parseInt(date2[1]);
				s += Integer.parseInt(date2[2]);
			}
		}
		return new Date(Y, M, D, H, m, s);
	}
	
	/**
	 * ʱ
	 * @param date1
	 * @param date2
	 * @param sT
	 * @return
	 */
	public static int diffString(String date1, String date2, String sT){
        return diffDate(formatDate(date1), formatDate(date2), sT);
	}
	
	/**
	 * ʱ
	 * @param date1
	 * @param date2
	 * @param sT
	 * @return
	 */
	public static int diffDate(Date date1, Date date2, String sT){
		long day1 = 0;
		long day2 = 0;
		long N = 1;
		if (sT.equals("D")){
			day1 = Date.UTC(date1.getYear(), date1.getMonth(), date1.getDate(), 0, 0, 0);
			day2 = Date.UTC(date2.getYear(), date2.getMonth(), date2.getDate(), 0, 0, 0);
			N = 86400000;
		} else if (sT.equals("H")){
			day1 = Date.UTC(date1.getYear(), date1.getMonth(), date1.getDate(), date1.getHours(), 0, 0);
			day2 = Date.UTC(date2.getYear(), date2.getMonth(), date2.getDate(), date2.getHours(), 0, 0);
			N = 3600000;
		} else if (sT.equals("M")){
			day1 = Date.UTC(date1.getYear(), date1.getMonth(), date1.getDate(), date1.getHours(), date1.getMinutes(), 0);
			day2 = Date.UTC(date2.getYear(), date2.getMonth(), date2.getDate(), date2.getHours(), date2.getMinutes(), 0);
			N = 60000;
		} else if (sT.equals("S")){
			day1 = Date.UTC(date1.getYear(), date1.getMonth(), date1.getDate(), date1.getHours(), date1.getMinutes(), date1.getSeconds());
			day2 = Date.UTC(date2.getYear(), date2.getMonth(), date2.getDate(), date2.getHours(), date2.getMinutes(), date2.getSeconds());
			N = 1000;
		} else {
			N = 1;
		}
        return (int)((day1 - day2) / N);
	}
	
	/**
	 * ȡ
	 * @param date
	 * @return
	 */
	public static String getDateTitle(Date date)
	{
		String T2 = "";		

        int N = diffDate(date, new Date(), "D");
		
    	if (N < 0){
    		if (N == -1){
	    		T2 = "";
	    	} else if (N == -2){
	    		T2 = "ǰ";
	    	}  else {
	    		T2 = Math.abs(N) + "ǰ";
	    	} 
    	} else if (N > 0){
    		if (N == 1){
	    		T2 = "";
	    	} else if (N == 2){
	    		T2 = "";
	    	}  else {
	    		T2 = Math.abs(N) + "";
	    	}
    	} else {
    		T2 = "";
    	}
    	
    	return T2;
	}
	
	public static String getDatePart(String datetime){
		String sDate = datetime.split(" ")[0];
		return sDate + " " + getWeekName(formatDate(sDate));
	}
	
	public static String getTimePart(String datetime){
		String times[] = datetime.split(" ")[1].split(":");		
		return times[0] + ":" + times[1];
	}
	
	public static String[] getTimes(String dates)
	{
		String results[] = new String[2];
		SimpleDateFormat dateFormat1 = new SimpleDateFormat("yyyy-MM-dd E,HH:mm");
		SimpleDateFormat dateFormat2 = new SimpleDateFormat("yyyy-MM-dd E,HH:mm");
		Date date = new Date();
		long date1, date2;
		if (!dates.equals("") && !dateFormat1.format(date).equals(dates)){
			date = formatDate(dates);
			date1 = date.getTime() + 3600000 * 9;
		} else { 
			date1 = date.getTime();
			date1 = date1 + (3600000 - date1 % 3600000);
		}
		date2 = date1 + 3600000;
		results[0] = dateFormat2.format(new Date(date1));
		results[1] = dateFormat2.format(new Date(date2));
		return results;
	}
	
	public static String NL_T2D(String S)
	{
		String results = S.substring(0, 4);
		int iY = S.indexOf("");
		int iM = S.indexOf("");
		String sM = S.substring(iY + 1, iM);
		String sD = S.substring(iM + 1, S.length());
		int i;
		for(i = 1; i <= 12; i++){ if (sM.equals(NL_M[i])){ results += "-" + String.valueOf(i); break; } }
		for(i = 1; i <= 30; i++){ if (sD.equals(NL_D[i])){ results += "-" + String.valueOf(i); break; } }
		return results;
	}
	
	public static String NL_D2T(String S)
	{
		String dates[] = S.split("-");
		int Y = Integer.parseInt(dates[0]);
		int M = Integer.parseInt(dates[1]);
		int D = Integer.parseInt(dates[2]);
		return (Y + getGanZhi(Y) + NL_SX[(Y-4)%12] + "" + NL_M[M] + "" + NL_D[D]);
	}

	public static String NLTitle(Date date)
	{
		LunarModel NL = GL2NL(date);
		return (NL.getY() + getGanZhi(NL.getY()) + NL_SX[(NL.getY()-4)%12] + '' + NL_M[NL.getM()] + '' + NL_D[NL.getD()]);
	}
	
	public static int getWeekDay(Date date)
	{
		return date.getDay();
	}
	
	public static int getWeekIndex(Date date)
	{
		int days = getFirstDate(date).getDay();
		int week = (date.getDate() + 7 - days) / 7;
		return week;
	}
}
