package com.cndatacom.crypto;

import java.security.Key;
import javax.crypto.Cipher;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.DESedeKeySpec;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;

public class Crypt_Des3 
{	 
    public static byte[] des3EncodeECB(byte[] key, byte[] data) throws Exception {
	    Key deskey = null;
	    DESedeKeySpec spec = new DESedeKeySpec(key);
	    SecretKeyFactory keyfactory = SecretKeyFactory.getInstance("desede");
	    deskey = keyfactory.generateSecret(spec);
	    Cipher cipher = Cipher.getInstance("desede" + "/ECB/PKCS5Padding");
	    cipher.init(Cipher.ENCRYPT_MODE, deskey);
	    byte[] bOut = cipher.doFinal(data);
	    return bOut;
    }

    public static byte[] des3DecodeECB(byte[] key, byte[] data) throws Exception {
        Key deskey = null;
        DESedeKeySpec spec = new DESedeKeySpec(key);
        SecretKeyFactory keyfactory = SecretKeyFactory.getInstance("desede");
        deskey = keyfactory.generateSecret(spec);
        Cipher cipher = Cipher.getInstance("desede" + "/ECB/PKCS5Padding");
        cipher.init(Cipher.DECRYPT_MODE, deskey);
        byte[] bOut = cipher.doFinal(data);
        return bOut;
    }

    public static byte[] des3EncodeCBC(byte[] key, byte[] keyiv, byte[] data) throws Exception {
    	Cipher c3des = Cipher.getInstance("DESede/CBC/PKCS5Padding");
		SecretKeySpec myKey = new SecretKeySpec(key,"DESede");
		IvParameterSpec ivspec = new IvParameterSpec(keyiv);
		c3des.init(Cipher.ENCRYPT_MODE, myKey, ivspec);
		byte[] encoded = c3des.doFinal(data);
		return encoded;
    }

    public static byte[] des3DecodeCBC(byte[] key, byte[] keyiv, byte[] data) throws Exception {
        Key deskey = null;
        DESedeKeySpec spec = new DESedeKeySpec(key);
        SecretKeyFactory keyfactory = SecretKeyFactory.getInstance("DESede");
        deskey = keyfactory.generateSecret(spec);
        Cipher cipher = Cipher.getInstance("DESede" + "/CBC/PKCS5Padding");
        IvParameterSpec ips = new IvParameterSpec(keyiv);
        cipher.init(Cipher.DECRYPT_MODE, deskey, ips);
        byte[] bOut = cipher.doFinal(data);
        return bOut;
    }
} 