package com.cndatacom.lang;

import java.util.Comparator;

import net.sourceforge.pinyin4j.PinyinHelper;

public class Pinyin implements Comparator<String>
{
    public int compare(String s1, String s2)
    {
    	char[] c1 = s1.toCharArray();
        char[] c2 = s2.toCharArray();
        String[] a1 = PinyinHelper.toHanyuPinyinStringArray(c1[0]);
        String[] a2 = PinyinHelper.toHanyuPinyinStringArray(c2[0]);
        String n1 = jionPinyin(a1);
        String n2 = jionPinyin(a2);
        return n1.compareTo(n2);
    }   

    private String jionPinyin(String[] pinyinArray)
    {
    	String results = "";
        StringBuffer sb = new StringBuffer();
        if (null != pinyinArray && pinyinArray.length > 0)
        {   
            for (int i = 0; i < pinyinArray.length; i++)
            {   
            	sb.append(pinyinArray[i]); 
            }
            results = sb.toString();
        }
        return results;   
    }
}
