package com.cndatacom.network;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.Proxy;
import java.net.URL;
import java.security.SecureRandom;

import javax.net.ssl.HostnameVerifier;
import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLContext;
import javax.net.ssl.X509TrustManager;
import java.security.cert.X509Certificate;

import org.apache.http.conn.ssl.AllowAllHostnameVerifier;

import android.content.Context;

public class Https
{  
	private static X509TrustManager XTM = new X509TrustManager() 
	{
		@Override
		public void checkClientTrusted(X509Certificate[] chain, String authType)
		{
			//
		}
		@Override
		public void checkServerTrusted(X509Certificate[] chain, String authType)
		{
			//
		}
		@Override
		public X509Certificate[] getAcceptedIssuers()
		{
			return new X509Certificate[]{};
		}
	};
	public static String post(Context context, String path, String data) throws Exception
	{
		String returnValue = "";
		try
		{
			StringBuilder sb = new StringBuilder();
			URL url = new URL(path);
			HttpsURLConnection conn = null;
			Proxy proxy = Utils.getProxy(context);
			if(null != proxy)
			{
				conn = (HttpsURLConnection) url.openConnection(proxy);
			} 
			else
			{
				conn = (HttpsURLConnection) url.openConnection();
		    }
			if (conn instanceof HttpsURLConnection)
			{
			     SSLContext sslContext = SSLContext.getInstance("TLS");
			     sslContext.init(null, new X509TrustManager[] { XTM }, new SecureRandom());
			     conn.setSSLSocketFactory(sslContext.getSocketFactory());
			     HostnameVerifier hv = new AllowAllHostnameVerifier();
			     conn.setHostnameVerifier(hv);
			}
	
			byte[] entity = data.getBytes();
			
			conn.setConnectTimeout(30000);
			conn.setRequestMethod("POST");
			conn.setDoOutput(true);
			conn.setRequestProperty("Content-Type", "application/x-www-form-urlencoded;charset=utf-8");
			conn.setRequestProperty("Content-Length", String.valueOf(entity.length));
			OutputStream writer = conn.getOutputStream();
			if (null != writer)
			{
				writer.write(entity);
				writer.flush();
				writer.close();
			}
			InputStream isReader = conn.getInputStream();
			BufferedReader reader = new BufferedReader(new InputStreamReader(isReader));
			String line = null;
	        while (null != (line = reader.readLine()))
	        {
	            sb.append(line);
	        }
	        reader.close();
	        conn.disconnect();
	        returnValue = sb.toString();
		}
		catch(Exception ex)
		{
			returnValue = "error: " + ex.toString();
		}
		
		return returnValue;
	}
}
