package com.cndatacom.utils;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import android.text.TextUtils;

/**
 * ؼ
 */
public class Regex
{
	/**
	 * ȡҳMETAContent
	 * @param sHTML : HTMLַ
	 * @param sName : META
	 * @return 
	 */
	public static String getMETAContent(String sHTML, String sName) 
	{
		String sResult = "";
		if (!TextUtils.isEmpty(sHTML))
		{
			String REGEX = "<meta\\s+http-equiv\\s*=\\s*\"\\s*" + sName + "\\s*\"\\s*content\\s*=\\s*\"(.+?)\\s*\"";
			Matcher M = Pattern.compile(REGEX, Pattern.CASE_INSENSITIVE).matcher(sHTML);
			if (M.find()) {
				sResult = M.group(1);
			}
		}
		return sResult;
	}
	/**
	 * ȡˢMETAURL
	 * @param sHTML : HTMLַ
	 * @return
	 */
	public static String getMETARefreshURL(String sHTML) 
	{
		String sResult = "";
		if (!TextUtils.isEmpty(sHTML))
		{
			String REGEX = "<meta\\s+http-equiv\\s*=\\s*\"\\s*refresh\\s*\"\\s*content\\s*=\\s*\".+url=(.+?)\\s*\"";
			Matcher M = Pattern.compile(REGEX, Pattern.CASE_INSENSITIVE).matcher(sHTML);
			if (M.find()) {
				sResult = M.group(1);
			}
		}
		return sResult;
	}
	/**
	 * ȡXMLĵַ
	 * @param sXML : XMLַ
	 * @param sRoot : ڵ
	 * @return
	 */
	public static String getXML(String sXML, String sRoot) 
	{
		String sResult = "";
		if (!TextUtils.isEmpty(sXML))
		{
			String REGEX = "<\\?xml\\s+[\\s\\S]+?</" + sRoot + ">";
			Matcher M = Pattern.compile(REGEX, Pattern.CASE_INSENSITIVE).matcher(sXML);
			if (M.find()) {
				int s = M.start();
				int e = M.end();
				if (s >= 0 && e >= 0) {
					sResult = sXML.substring(s, e);
				}
			}
		}
		return sResult;
	}
	/**
	 * ȡǩı
	 * @param sXML : ı
	 * @param sTag  ǩ
	 * @return
	 */
	public static String getTagTextContent(String sXML, String sTag) 
	{
		String sResult = "";
		if (!TextUtils.isEmpty(sXML))
		{
			String REGEX = "<" + sTag + "\\s+[\\s\\S]+?</" + sTag + ">";
			Matcher M = Pattern.compile(REGEX, Pattern.CASE_INSENSITIVE).matcher(sXML);
			if (M.find()) {
				int s = M.start();
				int e = M.end();
				if (s >= 0 && e >= 0) {
					sResult = sXML.substring(s, e);
					sResult = sResult.replace("</" + sTag + ">", "");
					int index = sResult.indexOf(">") + 1;
					if (index > 0){
						sResult = sResult.substring(index, sResult.length() - index);
					}
				}
			}
		}
		return sResult;
	}
}
